﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.Layouts;

namespace _1001735_RadListView
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radListView1.VisualItemCreating += new ListViewVisualItemCreatingEventHandler(radListView1_VisualItemCreating);
            this.radListView1.VisualItemFormatting += new ListViewVisualItemEventHandler(radListView1_VisualItemFormatting);
        }

        void radListView1_VisualItemFormatting(object sender, ListViewVisualItemEventArgs e)
        {
            if (e.VisualItem.Selected == true)
            {
                e.VisualItem.BackColor = Color.Transparent;
                e.VisualItem.NumberOfColors = 1;
                e.VisualItem.GradientStyle = Telerik.WinControls.GradientStyles.Solid;
            }
            else
            {
                e.VisualItem.ResetValue(LightVisualElement.BackColorProperty, Telerik.WinControls.ValueResetFlags.Local);
                e.VisualItem.ResetValue(LightVisualElement.NumberOfColorsProperty, Telerik.WinControls.ValueResetFlags.Local);
                e.VisualItem.ResetValue(LightVisualElement.GradientStyleProperty, Telerik.WinControls.ValueResetFlags.Local);
            }
        }

        void radListView1_VisualItemCreating(object sender, ListViewVisualItemCreatingEventArgs e)
        {
            if (this.radListView1.ViewType == ListViewType.ListView)
            {
                e.VisualItem = new MyCustomVisualItem();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.customersTableAdapter.Fill(this.nwindDataSet.Customers);
        }
    }

    public class MyCustomVisualItem : SimpleListViewVisualItem
    {
        private RadButtonElement buttonElement1;
        private RadButtonElement buttonElement2;
        private LightVisualElement contentElement;
        private StackLayoutPanel stackLayout;

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            this.stackLayout = new StackLayoutPanel();
            this.stackLayout.Orientation = Orientation.Horizontal;
            this.stackLayout.EqualChildrenWidth = true;
            this.stackLayout.ShouldHandleMouseInput = false;
            this.stackLayout.NotifyParentOnMouseInput = true;

            this.contentElement = new LightVisualElement();
            this.contentElement.StretchHorizontally = true;
            this.contentElement.MinSize = new Size(120, 0);
            this.contentElement.ShouldHandleMouseInput = false;
            this.contentElement.NotifyParentOnMouseInput = true;
            this.stackLayout.Children.Add(this.contentElement);

            this.buttonElement1 = new RadButtonElement();
            this.buttonElement1.Text = "Button1";
            this.stackLayout.Children.Add(this.buttonElement1);

            this.buttonElement2 = new RadButtonElement();
            this.buttonElement2.Text = "Button2";
            buttonElement2.SetThemeValueOverride(Telerik.WinControls.Primitives.BorderPrimitive.ForeColorProperty,
                Color.Gray, "", typeof(Telerik.WinControls.Primitives.BorderPrimitive));
            buttonElement2.SetThemeValueOverride(Telerik.WinControls.Primitives.BorderPrimitive.ForeColorProperty,
                Color.Blue, "MouseOver", typeof(Telerik.WinControls.Primitives.BorderPrimitive));
            buttonElement2.SetThemeValueOverride(Telerik.WinControls.Primitives.FillPrimitive.BackColorProperty,
                Color.Aquamarine, "", typeof(Telerik.WinControls.Primitives.FillPrimitive));
            buttonElement2.SetThemeValueOverride(Telerik.WinControls.Primitives.FillPrimitive.NumberOfColorsProperty,
                1, "", typeof(Telerik.WinControls.Primitives.FillPrimitive));

            this.stackLayout.Children.Add(this.buttonElement2);
            this.Children.Add(this.stackLayout);
        }

        protected override void SynchronizeProperties()
        {
            base.SynchronizeProperties();

            this.Text = "";
            this.contentElement.Text = Convert.ToString(this.Data["Name"]);
            this.buttonElement1.Text = "Call " + Convert.ToString(this.Data["Phone"]);
            this.buttonElement2.Text = "Fax " + Convert.ToString(this.Data["Fax"]);
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(SimpleListViewVisualItem);
            }
        }
    }
}